diff -bruN freeswan-1.9.orig/lib/pfkey_v2_parse.c freeswan-1.9/lib/pfkey_v2_parse.c
--- freeswan-1.9.orig/lib/pfkey_v2_parse.c	Fri Dec  1 02:09:00 2000
+++ freeswan-1.9/lib/pfkey_v2_parse.c	Wed May 16 10:57:20 2001
@@ -1152,7 +1215,8 @@
 		if((extensions_seen & ( 1 << pfkey_ext->sadb_ext_type )) != 0)
 		{
 			DEBUGGING(
-				"pfkey_msg_parse: ext type %d already seen.\n", 
+				"pfkey_msg_parse: "
+				"ext type %d already seen.\n", 
 				pfkey_ext->sadb_ext_type);
 			SENDERR(EINVAL);
 		}
@@ -1160,7 +1224,8 @@
 		/* Do I even know about this type of extension? */
 		if(!(ext_parsers[pfkey_ext->sadb_ext_type])) {
 			DEBUGGING(
-				"pfkey_msg_parse: ext type %d unknown, ignoring.\n", 
+				"pfkey_msg_parse: "
+				"ext type %d unknown, ignoring.\n", 
 				pfkey_ext->sadb_ext_type);
 			goto next_ext;
 		}
@@ -1169,7 +1234,8 @@
 		if(!(extensions_bitmaps[dir][EXT_BITS_PERM][pfkey_msg->sadb_msg_type] &
 		     1<<pfkey_ext->sadb_ext_type)) {
 			DEBUGGING(
-				"pfkey_msg_parse: ext type %d not permitted, exts_perm_in=%08x, 1<<type=%08x\n", 
+				"pfkey_msg_parse: "
+				"ext type %d not permitted, exts_perm_in=%08x, 1<<type=%08x\n", 
 				pfkey_ext->sadb_ext_type, 
 				extensions_bitmaps[dir][EXT_BITS_PERM][pfkey_msg->sadb_msg_type],
 				1<<pfkey_ext->sadb_ext_type);
@@ -1177,19 +1243,22 @@
 		}
 
 		DEBUGGING(
-			"pfkey_msg_parse: About to parse extension %d %p with parser %p.\n",
+			"pfkey_msg_parse: "
+			"About to parse extension %d %p with parser %p.\n",
 			pfkey_ext->sadb_ext_type,
 			pfkey_ext,
 			ext_parsers[pfkey_ext->sadb_ext_type]);
 		/* Parse the extension */
 		if((error = ext_parsers[pfkey_ext->sadb_ext_type](pfkey_ext))) {
 			DEBUGGING(
-				"pfkey_msg_parse: extension parsing for type %d failed with error %d.\n",
+				"pfkey_msg_parse: "
+				"extension parsing for type %d failed with error %d.\n",
 				pfkey_ext->sadb_ext_type, error); 
 			SENDERR(-error);
 		}
 		DEBUGGING(
-			"pfkey_msg_parse: Extension %d parsed.\n",
+			"pfkey_msg_parse: "
+			"Extension %d parsed.\n",
 			pfkey_ext->sadb_ext_type);
 		
 		/* Mark that we have seen this extension and remember the header location */
@@ -1210,7 +1279,8 @@
 
 	if(remain) {
 		DEBUGGING(
-			"pfkey_msg_parse: unexpected remainder of %d.\n", 
+			"pfkey_msg_parse: "
+			"unexpected remainder of %d.\n", 
 			remain);
 		/* why is there still something remaining? */
 		SENDERR(EINVAL);
@@ -1218,8 +1288,8 @@
 
 	/* check required extensions */
 	DEBUGGING(
-		"pfkey_msg_parse: extensions "
-		"permitted=%08x, seen=%08x, required=%08x.\n",
+		"pfkey_msg_parse: "
+		"extensions permitted=%08x, seen=%08x, required=%08x.\n",
 		extensions_bitmaps[dir][EXT_BITS_PERM][pfkey_msg->sadb_msg_type],
 		extensions_seen,
 		extensions_bitmaps[dir][EXT_BITS_REQ][pfkey_msg->sadb_msg_type]);
@@ -1227,14 +1297,15 @@
 	/* don't check further if it is an error return message since it
 	   may not have a body */
 	if(pfkey_msg->sadb_msg_errno) {
-		return error;
+		SENDERR(-error);
 	}
 
 	if((extensions_seen &
 	    extensions_bitmaps[dir][EXT_BITS_REQ][pfkey_msg->sadb_msg_type]) !=
 	   extensions_bitmaps[dir][EXT_BITS_REQ][pfkey_msg->sadb_msg_type]) {
 		DEBUGGING(
-			"pfkey_msg_parse: required extensions missing:%08x.\n",
+			"pfkey_msg_parse: "
+			"required extensions missing:%08x.\n",
 			extensions_bitmaps[dir][EXT_BITS_REQ][pfkey_msg->sadb_msg_type] -
 			(extensions_seen &
 			 extensions_bitmaps[dir][EXT_BITS_REQ][pfkey_msg->sadb_msg_type]));
@@ -1257,9 +1328,9 @@
 		SENDERR(EINVAL);
 	}
 	
-	if((pfkey_msg->sadb_msg_type == SADB_ADD) ||
-	   (pfkey_msg->sadb_msg_type == SADB_UPDATE)) {
-
+	switch(pfkey_msg->sadb_msg_type) {
+	case SADB_ADD:
+	case SADB_UPDATE:
 		/* check maturity */
 		if(((struct sadb_sa*)extensions[SADB_EXT_SA])->sadb_sa_state !=
 		   SADB_SASTATE_MATURE) {
@@ -1272,8 +1343,8 @@
 		}
 		
 		/* check AH and ESP */
-		if(((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype ==
-		   SADB_SATYPE_AH) {
+		switch(((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype) {
+		case SADB_SATYPE_AH:
 			if(!(((struct sadb_sa*)extensions[SADB_EXT_SA]) &&
 			     ((struct sadb_sa*)extensions[SADB_EXT_SA])->sadb_sa_auth !=
 			     SADB_AALG_NONE)) {
@@ -1290,10 +1361,8 @@
 					((struct sadb_sa*)(extensions[SADB_EXT_SA]))->sadb_sa_encrypt);
 				SENDERR(EINVAL);
 			}
-		}
-		
-		if(((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype ==
-		   SADB_SATYPE_ESP) {
+			break;
+		case SADB_SATYPE_ESP:
 			if(!(((struct sadb_sa*)extensions[SADB_EXT_SA]) &&
 			     ((struct sadb_sa*)extensions[SADB_EXT_SA])->sadb_sa_encrypt !=
 			     SADB_EALG_NONE)) {
@@ -1313,10 +1382,8 @@
 					"ESP handed encNULL+authNONE, illegal combination.\n");
 				SENDERR(EINVAL);
 			}
-		}
-
-		if(((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype ==
-		   SADB_X_SATYPE_COMP) {
+			break;
+		case SADB_X_SATYPE_COMP:
 			if(!(((struct sadb_sa*)extensions[SADB_EXT_SA]) &&
 			     ((struct sadb_sa*)extensions[SADB_EXT_SA])->sadb_sa_encrypt !=
 			     SADB_EALG_NONE)) {
@@ -1327,7 +1394,25 @@
 					((struct sadb_msg*)extensions[SADB_EXT_RESERVED])->sadb_msg_satype);
 				SENDERR(EINVAL);
 			}
+			if(((struct sadb_sa*)(extensions[SADB_EXT_SA]))->sadb_sa_auth !=
+			   SADB_AALG_NONE) {
+				DEBUGGING(
+					"pfkey_msg_parse: "
+					"COMP handed auth=%d, must be zero.\n",
+					((struct sadb_sa*)(extensions[SADB_EXT_SA]))->sadb_sa_auth);
+				SENDERR(EINVAL);
+			}
+			break;
+		default:
+		}
+		if(ntohl(((struct sadb_sa*)(extensions[SADB_EXT_SA]))->sadb_sa_spi) <= 255) {
+			DEBUGGING(
+				"pfkey_msg_parse: "
+				"spi=%08x must be > 255.\n",
+				ntohl(((struct sadb_sa*)(extensions[SADB_EXT_SA]))->sadb_sa_spi));
+			SENDERR(EINVAL);
 		}
+	default:	
 	}
 errlab:
 
@@ -1336,6 +1421,27 @@
 
 /*
  * $Log: pfkey_v2_parse.c,v $
+ * Revision 1.35  2001/05/03 19:44:51  rgb
+ * Standardise on SENDERR() macro.
+ *
+ * Revision 1.34  2001/03/16 07:41:51  rgb
+ * Put freeswan.h include before pluto includes.
+ *
+ * Revision 1.33  2001/02/27 07:13:51  rgb
+ * Added satype2name() function.
+ * Added text to default satype_tbl entry.
+ * Added satype2name() conversions for most satype debug output.
+ *
+ * Revision 1.32  2001/02/26 20:01:09  rgb
+ * Added internal IP protocol 61 for magic SAs.
+ * Ditch unused sadb_satype2proto[], replaced by satype2proto().
+ * Re-formatted debug output (split lines, consistent spacing).
+ * Removed acquire, register and expire requirements for a known satype.
+ * Changed message type checking to a switch structure.
+ * Verify expected NULL auth for IPCOMP.
+ * Enforced spi > 0x100 requirement, now that pass uses a magic SA for
+ * appropriate message types.
+ *
  * Revision 1.31  2000/12/01 07:09:00  rgb
  * Added ipcomp sanity check to require encalgo is set.
  *
diff -bruN freeswan-1.9.orig/lib/pfkeyv2.h freeswan-1.9/lib/pfkeyv2.h
--- freeswan-1.9.orig/lib/pfkeyv2.h	Thu Feb  8 13:51:05 2001
+++ freeswan-1.9/lib/pfkeyv2.h	Wed May 16 10:57:20 2001
@@ -1,5 +1,5 @@
 /*
- * RCSID $Id: pfkeyv2.h,v 1.14 2001/02/08 18:51:05 rgb Exp $
+ * RCSID $Id: pfkeyv2.h,v 1.15 2001/02/26 20:00:43 rgb Exp $
  */
 
 /*
@@ -231,7 +231,8 @@
 #define SADB_SATYPE_MIP       8
 #define SADB_X_SATYPE_IPIP    9
 #define SADB_X_SATYPE_COMP    10
-#define SADB_SATYPE_MAX       10
+#define SADB_X_SATYPE_INT     11
+#define SADB_SATYPE_MAX       11
 
 #define SADB_SASTATE_LARVAL   0
 #define SADB_SASTATE_MATURE   1
@@ -280,6 +281,9 @@
 
 /*
  * $Log: pfkeyv2.h,v $
+ * Revision 1.15  2001/02/26 20:00:43  rgb
+ * Added internal IP protocol 61 for magic SAs.
+ *
  * Revision 1.14  2001/02/08 18:51:05  rgb
  * Include RFC document title and appendix subsection title.
  *
diff -bruN freeswan-1.9.orig/lib/satoa.c freeswan-1.9/lib/satoa.c
--- freeswan-1.9.orig/lib/satoa.c	Sat Sep 16 02:43:47 2000
+++ freeswan-1.9/lib/satoa.c	Mon Jun  4 12:58:45 2001
@@ -1,6 +1,6 @@
 /*
  * convert from binary form of SA ID to ASCII
- * Copyright (C) 1998, 1999  Henry Spencer.
+ * Copyright (C) 1998, 1999, 2001  Henry Spencer.
  * 
  * This library is free software; you can redistribute it and/or modify it
  * under the terms of the GNU Library General Public License as published by
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
  * License for more details.
  *
- * RCSID $Id: satoa.c,v 1.9 2000/09/16 06:43:47 henry Exp $
+ * RCSID $Id: satoa.c,v 1.11 2001/06/01 16:44:48 henry Exp $
  */
 #include "internal.h"
 #include "freeswan.h"
@@ -25,6 +25,7 @@
 	{ SA_ESP,	"esp" },
 	{ SA_IPIP,	"tun" },
 	{ SA_COMP,	"comp" },
+	{ SA_INT,	"int" },
 	{ 0,		NULL }
 };
 
@@ -38,7 +39,7 @@
 char *dst;			/* need not be valid if dstlen is 0 */
 size_t dstlen;
 {
-	size_t len;
+	size_t len = 0;		/* 0 means not handled yet */
 	int base;
 	struct typename *tn;
 	char buf[30+ADDRTOA_BUF];
@@ -66,7 +67,24 @@
 					sa.dst.s_addr == PASSTHROUGHDST) {
 		strcpy(buf, PASSTHROUGHNAME);
 		len = strlen(buf);
-	} else {
+	} else if (sa.proto == SA_INT && sa.dst.s_addr == 0) {
+		char *p;
+
+		switch (ntohl(sa.spi)) {
+		case SPI_PASS:	p = "%pass";	break;
+		case SPI_DROP:	p = "%drop";	break;
+		case SPI_REJECT:	p = "%reject";	break;
+		case SPI_HOLD:	p = "%hold";	break;
+		case SPI_TRAP:	p = "%trap";	break;
+		default:	p = NULL;	break;
+		}
+		if (p != NULL) {
+			strcpy(buf, p);
+			len = strlen(buf);
+		}
+	}
+
+	if (len == 0) {
 		strcpy(buf, tn->name);
 		len = strlen(buf);
 		len += ultoa(ntohl(sa.spi), base, buf+len, sizeof(buf)-len);
diff -bruN freeswan-1.9.orig/lib/satot.c freeswan-1.9/lib/satot.c
--- freeswan-1.9.orig/lib/satot.c	Fri Sep 15 13:02:52 2000
+++ freeswan-1.9/lib/satot.c	Wed May 16 10:57:20 2001
@@ -1,6 +1,6 @@
 /*
  * convert from binary form of SA ID to text
- * Copyright (C) 2000  Henry Spencer.
+ * Copyright (C) 2000, 2001  Henry Spencer.
  * 
  * This library is free software; you can redistribute it and/or modify it
  * under the terms of the GNU Library General Public License as published by
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
  * License for more details.
  *
- * RCSID $Id: satot.c,v 1.4 2000/09/15 17:02:52 henry Exp $
+ * RCSID $Id: satot.c,v 1.7 2001/02/27 19:30:16 henry Exp $
  */
 #include "internal.h"
 #include "freeswan.h"
@@ -25,6 +25,7 @@
 	{ SA_ESP,	"esp" },
 	{ SA_IPIP,	"tun" },
 	{ SA_COMP,	"comp" },
+	{ SA_INT,	"int" },
 	{ 0,		NULL }
 };
 
@@ -38,11 +39,14 @@
 char *dst;			/* need not be valid if dstlen is 0 */
 size_t dstlen;
 {
-	size_t len;
+	size_t len = 0;		/* 0 means "not recognized yet" */
 	int base;
 	int showversion;	/* use delimiter to show IP version? */
 	struct typename *tn;
-	char buf[3+1+ULTOT_BUF+ADDRTOT_BUF];
+	char *p;
+	char *pre;
+	char buf[10+1+ULTOT_BUF+ADDRTOT_BUF];
+	char unk[10];
 
 	switch (format) {
 	case 0:
@@ -66,21 +70,46 @@
 		break;
 	}
 
+	pre = NULL;
 	for (tn = typenames; tn->name != NULL; tn++)
-		if (sa->proto == tn->type)
-			break;
-	if (tn->name == NULL)
-		return 0;
+		if (sa->proto == tn->type) {
+			pre = tn->name;
+			break;			/* NOTE BREAK OUT */
+		}
+	if (pre == NULL) {		/* unknown protocol */
+		strcpy(unk, "unk");
+		(void) ultot((unsigned char)sa->proto, 10, unk+strlen(unk),
+						sizeof(unk)-strlen(unk));
+		pre = unk;
+	}
 
-	if (strcmp(tn->name, PASSTHROUGHTYPE) == 0 &&
+	if (strcmp(pre, PASSTHROUGHTYPE) == 0 &&
 					sa->spi == PASSTHROUGHSPI &&
 					isunspecaddr(&sa->dst)) {
 		strcpy(buf, (addrtypeof(&sa->dst) == AF_INET) ?
 							PASSTHROUGH4NAME :
 							PASSTHROUGH6NAME);
 		len = strlen(buf);
-	} else {
-		strcpy(buf, tn->name);
+	}
+	
+	if (sa->proto == SA_INT && addrtypeof(&sa->dst) == AF_INET &&
+						isunspecaddr(&sa->dst)) {
+		switch (ntohl(sa->spi)) {
+		case SPI_PASS:	p = "%pass";	break;
+		case SPI_DROP:	p = "%drop";	break;
+		case SPI_REJECT:	p = "%reject";	break;
+		case SPI_HOLD:	p = "%hold";	break;
+		case SPI_TRAP:	p = "%trap";	break;
+		default:	p = NULL;	break;
+		}
+		if (p != NULL) {
+			strcpy(buf, p);
+			len = strlen(buf);
+		}
+	}
+
+	if (len == 0) {			/* general case needed */
+		strcpy(buf, pre);
 		len = strlen(buf);
 		if (showversion) {
 			*(buf+len) = (addrtypeof(&sa->dst) == AF_INET) ? '.' :
diff -bruN freeswan-1.9.orig/lib/ttosa.c freeswan-1.9/lib/ttosa.c
--- freeswan-1.9.orig/lib/ttosa.c	Fri Sep 15 15:20:33 2000
+++ freeswan-1.9/lib/ttosa.c	Wed May 16 10:57:20 2001
@@ -1,6 +1,6 @@
 /*
  * convert from text form of SA ID to binary
- * Copyright (C) 2000  Henry Spencer.
+ * Copyright (C) 2000, 2001  Henry Spencer.
  * 
  * This library is free software; you can redistribute it and/or modify it
  * under the terms of the GNU Library General Public License as published by
@@ -12,7 +12,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
  * License for more details.
  *
- * RCSID $Id: ttosa.c,v 1.6 2000/09/15 19:20:33 henry Exp $
+ * RCSID $Id: ttosa.c,v 1.8 2001/02/27 19:28:32 henry Exp $
  */
 #include "internal.h"
 #include "freeswan.h"
@@ -26,9 +26,25 @@
 	{ "esp",	3,	SA_ESP	},
 	{ "tun",	3,	SA_IPIP },
 	{ "comp",	4,	SA_COMP },
+	{ "int",	3,	SA_INT	},
 	{ NULL,		0,	0,	}
 };
 
+static struct magic {
+	char *name;
+	char *really;
+} magic[] = {
+	{ PASSTHROUGHNAME,	PASSTHROUGH4IS		},
+	{ PASSTHROUGH4NAME,	PASSTHROUGH4IS		},
+	{ PASSTHROUGH6NAME,	PASSTHROUGH6IS		},
+	{ "%pass",		"int256@0.0.0.0"	},
+	{ "%drop",		"int257@0.0.0.0"	},
+	{ "%reject",		"int258@0.0.0.0"	},
+	{ "%hold",		"int259@0.0.0.0"	},
+	{ "%trap",		"int260@0.0.0.0"	},
+	{ NULL,			NULL			}
+};
+
 /*
  - ttosa - convert text "ah507@10.0.0.1" to SA identifier
  */
@@ -45,13 +61,9 @@
 	struct satype *sat;
 	unsigned long ul;
 	const char *oops;
+	struct magic *mp;
+	size_t nlen;
 #	define	MINLEN	5	/* ah0@0 is as short as it can get */
-	static char ptname[] = PASSTHROUGHNAME;
-#	define	PTNLEN	(sizeof(ptname)-1)	/* -1 for NUL */
-	static char pt4name[] = PASSTHROUGH4NAME;
-#	define	PT4NLEN	(sizeof(pt4name)-1)	/* -1 for NUL */
-	static char pt6name[] = PASSTHROUGH6NAME;
-#	define	PT6NLEN	(sizeof(pt6name)-1)	/* -1 for NUL */
 	int af;
 	int base;
 
@@ -61,14 +73,15 @@
 		return "empty string";
 	if (srclen < MINLEN)
 		return "string too short to be SA identifier";
-	if (srclen == PTNLEN && memcmp(src, ptname, PTNLEN) == 0) {
-		src = PASSTHROUGH4IS;
-		srclen = strlen(src);
-	} else if (srclen == PT4NLEN && memcmp(src, pt4name, PT4NLEN) == 0) {
-		src = PASSTHROUGH4IS;
-		srclen = strlen(src);
-	} else if (srclen == PT6NLEN && memcmp(src, pt6name, PT6NLEN) == 0) {
-		src = PASSTHROUGH6IS;
+	if (*src == '%') {
+		for (mp = magic; mp->name != NULL; mp++) {
+			nlen = strlen(mp->name);
+			if (srclen == nlen && memcmp(src, mp->name, nlen) == 0)
+				break;
+		}
+		if (mp->name == NULL)
+			return "unknown % keyword";
+		src = mp->really;
 		srclen = strlen(src);
 	}
 
@@ -174,6 +187,7 @@
 
 struct rtab {
 	int format;
+#		define	FUDGE	0x1000
 	char *input;
 	char *output;			/* NULL means error expected */
 } rtab[] = {
@@ -205,6 +219,19 @@
 	0, "esp7x7@1.2.3.4",		NULL,
 	0, "esp77@1.0x2.3.4",		NULL,
 	0, PASSTHROUGHNAME,		PASSTHROUGH4NAME,
+	0, PASSTHROUGH6NAME,		PASSTHROUGH6NAME,
+	0, "%pass",			"%pass",
+	0, "int256@0.0.0.0",		"%pass",
+	0, "%drop",			"%drop",
+	0, "int257@0.0.0.0",		"%drop",
+	0, "%reject",			"%reject",
+	0, "int258@0.0.0.0",		"%reject",
+	0, "%hold",			"%hold",
+	0, "int259@0.0.0.0",		"%hold",
+	0, "%trap",			"%trap",
+	0, "int260@0.0.0.0",		"%trap",
+	0, "int261@0.0.0.0",		"int.105@0.0.0.0",
+	FUDGE, "esp9@1.2.3.4",		"unk77.9@1.2.3.4",
 	0, NULL,			NULL
 };
 
@@ -232,7 +259,9 @@
 								r->input);
 			status = 1;
 		} else {
-			n = satot(&sa, r->format, buf, sizeof(buf));
+			if (r->format&FUDGE)
+				sa.proto = 77;
+			n = satot(&sa, (char)r->format, buf, sizeof(buf));
 			if (n > sizeof(buf)) {
 				printf("`%s' satot failed:  need %ld\n",
 							r->input, (long)n);
diff -bruN freeswan-1.9.orig/libdes/Makefile freeswan-1.9/libdes/Makefile
--- freeswan-1.9.orig/libdes/Makefile	Tue Oct 10 22:12:45 2000
+++ freeswan-1.9/libdes/Makefile	Wed May 16 10:57:20 2001
@@ -59,10 +59,10 @@
 #DES_ENC=asm/dx86-sol.o	asm/yx86-sol.o	# solaris format x86 
 #DES_ENC=asm/dx86bsdi.o	asm/yx86basi.o	# bsdi format x86 
 
-LIBDIR=/usr/local/lib
-BINDIR=/usr/local/bin
-INCDIR=/usr/local/include
-MANDIR=/usr/local/man
+LIBDIR=/usr/lib
+BINDIR=/usr/bin
+INCDIR=/usr/include
+MANDIR=/usr/man
 MAN1=1
 MAN3=3
 SHELL=/bin/sh
diff -bruN freeswan-1.9.orig/pluto/CHANGES freeswan-1.9/pluto/CHANGES
--- freeswan-1.9.orig/pluto/CHANGES	Wed Jan 31 20:54:09 2001
+++ freeswan-1.9/pluto/CHANGES	Mon Jun  4 12:59:59 2001
@@ -1,7 +1,83 @@
 Changes to Pluto
 ================
 
+Changes since 1.9 release by D. Hugh Redelmeier <hugh@mimosa.com>
+
+- refined the code for DODGE_DH_MISSING_ZERO_BUG to ensure
+  Responder never drops a negotiation.
+
+- added and exploited builddiag(), a routine make it easier to add
+  intermediate context to diagnostics.
+
+- For purposes of IPv4, Pluto will now only consider interfaces that
+  are "up".  It has always ignored those configured with address
+  0.0.0.0, thus ignoring "down" interfaces in most cases.
+
+- add a list of interface pairs to --status output.
+
+- replace signal(2) calls with sigaction(2) calls: glibc has further
+  broken the semantics of signal(2).  We want slow system calls
+  to be interruptable and not be restarted.
+
+- improved error message for lack of preshared key by showing
+  IDs that were used in lookup.  Collateral tidying.
+
+- documented complex logic of routing and erouting in routing.txt
+
+- When a connection is --routed, a route is installed to direct
+  outbound packets destined for the peer's client to go to the ipsec
+  interface implicit in the connection.  This is not allowed for Road
+  Warrior connections -- they are strictly inbound.  For Opportunistic
+  connections, a new default root is installed that points to the
+  ipsec interface.  Note that the route does not take into account the
+  source address.  In addition, a TRAP shunt eroute is installed to
+  catch any traffic sent on the not-yet-initiated connection.
+
+- When an outbound packet is trapped by the TRAP shunt eroute,
+  Pluto attempts to initiate the corresponding connection.
+  If the attempt fails because an Opportunistic connection was used
+  and no gateway information was found, a PASS shunt eroute is
+  installed (with no provision for automatic removal).
+
+- if negotiation fails at a later point, a shunt eroute is installed.
+  The kind of shunt is a policy decision.  It is specified as part of
+  the connection.  (Untested; can not be specified in ipsec.conf.)
+
+- When an inbound negotiation doesn't match a specific connection,
+  and there is an Opportunistic connection, Pluto will try to respond
+  using that connection.
+
+- Every 2 minutes (SHUNT_SCAN_INTERVAL seconds), Pluto scans for
+
+  + PASS eroutes that it installed that haven't been used recently.
+    These will be deleted.
+
+  + HOLD eroutes for which Pluto hasn't received a PFKEY_ACQUIRE message.
+    For any it finds, it will attempt an opportunistic initiate.
+
+- We no longer allow Phase 1 negotiations that we initiate to switch
+  which connection is being used based on the Peer's Phase 1 ID.
+  The fact that we used to do so was probably a bug.
+
+- When Pluto as the Responder receives the Peer's Phase 1 ID, it is
+  now willing to use a connection with a different ID and private
+  RSA key for our end.  Nothing has committed us to the current guess.
+
+- Changes in internal data structures to aid in better tracking of
+  history of attempted and successful communication.  Needed for
+  effective Opportunism.
+  + struct host_pair represents information about pairs of hosts.
+  + "Orientation" is done as soon as possible rather than as late
+    as possible.
+  + an arbitrary number of Quick Mode negotiations may now queue
+    for the completion of a Main Mode negotiation.  Formerly,
+    a negotiation could only use a previously completed Keying Channel.
+
+
 Changes since 1.8 release by D. Hugh Redelmeier <hugh@mimosa.com>
+
+- [Svenning Soerensen] correct check requiring OAKLEY_LIFE_TYPE
+  attribute before OAKLEY_LIFE_DURATION.
 
 - Improved whack diagnostics for various cases of failure to connect
   with Pluto.
diff -bruN freeswan-1.9.orig/pluto/Makefile freeswan-1.9/pluto/Makefile
--- freeswan-1.9.orig/pluto/Makefile	Wed Oct 25 19:58:15 2000
+++ freeswan-1.9/pluto/Makefile	Mon Jun  4 13:02:07 2001
@@ -12,7 +12,7 @@
 # or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 # for more details.
 #
-# RCSID $Id: Makefile,v 1.75 2000/10/25 23:58:15 henry Exp $
+# RCSID $Id: Makefile,v 1.76 2001/03/13 09:22:01 dhr Exp $
 
 SHELL = /bin/sh
 
@@ -31,17 +31,32 @@
 FREESWANLIB=$(FREESWANLIBDIR)/libfreeswan.a
 LIBDESLITE=$(FREESWANLIBDIR)/libdes.a
 
+ifeq "$(USEOPENSSL)" "1"
+OPENSSLDEFS=-DOPENSSL
+
+OPENSSLOBJS=openssl.o xmap.o xmap_file.o xmap_dir.o xmap_db.o xmap_ldap.o \
+	x_sobj.o
+
+LDAPLIBS=-L$(LDAPROOT)/lib -lldap -llber -Wl,-rpath $(LDAPROOT)/lib
+LDAPDEFS=-DHAVE_LDAP
+
+DBROOT=/usr
+DBINCS=-I$(DBROOT)/include
+DBLIBS=-L$(DBROOT)/lib -ldb
+DBDEFS=-DHAVE_DB -DHAVE_DB185
+endif # USEOPENSSL = 1
+
 KLIPSD=../klips/net/ipsec
 
 INSTALL=install
 
 # -O on Linux makes gcc coredump when compiling sha1.c
 # -Wundef is nice but RHL5.2 compiler doesn't support it
-CFLAGS = -g -Wall -W -Wmissing-prototypes -Wpointer-arith -Wbad-function-cast \
-	-Wcast-qual -Wmissing-declarations -Wwrite-strings -Wstrict-prototypes
+CFLAGS = -g -Wall -Wmissing-prototypes -Wpointer-arith -Wbad-function-cast \
+	-Wcast-qual -Wmissing-declarations -Wwrite-strings
 
 # where to find klips headers and FreeS/WAN headers
-HDRDIRS = -I$(KLIPSD) $(FREESWANINCLS)
+HDRDIRS = -I$(KLIPSD) $(FREESWANINCLS) $(OPENSSLINCLS) $(LDAPINCS) $(DBINCS)
 
 # On non-LINUX systems, these one of these may be needed (see endian.h)
 # BYTE_ORDER = -DBIG_ENDIAN=4321 -DLITTLE_ENDIAN=1234 -DBYTE_ORDER=BIG_ENDIAN
@@ -76,22 +91,31 @@
 
 CPPFLAGS = $(HDRDIRS) $(BYTE_ORDER) \
 	-DPLUTO -DKLIPS -DDODGE_DH_MISSING_ZERO_BUG \
-	-DDEBUG -DGCC_LINT
+	-DDEBUG -DGCC_LINT $(OPENSSLDEFS) $(LDAPDEFS) $(DBDEFS)
 
 ALLFLAGS = $(CPPFLAGS) $(CFLAGS)
 
 # libefence is a free memory allocation debugger
 # Solaris 2 needs -lsocket -lnsl
-LIBSPLUTO = -lgmp -lresolv # -lefence
+LIBSPLUTO = -lgmp -lresolv $(OPENSSLLIBS) $(LDAPLIBS) $(DBLIBS)  # -lefence
 
 LDFLAGS =
 
 # Solaris needs -lsocket -lnsl
 LIBSWHACK =
 
+LIBSD2H   = $(OPENSSLLIBS) $(DBLIBS)
+
 BINNAMEPLUTO = pluto
 BINNAMEWHACK = whack
 
+# Comment this out if you don't have Berkeley DB available, which,
+# if you're running Linux is a bit strange...
+#ifeq ($(USEOPENSSL),1)
+ifeq "$(USEOPENSSL)" "1"
+BINNAMED2H   = dir2hash
+endif
+
 RM = /bin/rm
 RMFLAGS = -f
 
@@ -100,12 +124,12 @@
 
 # files for a (source) distribution
 
-DISTMISC = CHANGES TODO ipsec.secrets Makefile \
+DISTMISC = CHANGES TODO ipsec.secrets Makefile routing.txt \
 	 pluto.8 ipsec.secrets.5
 
 DISTGCRYPT = \
 	gcryptfix.c gcryptfix.h \
-	dsa.c dsa.h \
+        g10_dsa.c g10_dsa.h \
 	elgamal.c elgamal.h \
 	primegen.c \
 	smallprime.c
@@ -142,23 +166,30 @@
 
 # start of support for DSS/DSA.  Not currently used.
 # OBJSGCRYPT =  gcryptfix.o dsa.o elgamal.o primegen.o smallprime.o
-OBJSGCRYPT =
+OBJSGCRYPT = gcryptfix.o g10_dsa.o elgamal.o primegen.o smallprime.o
 
 OBJSPLUTO = connections.o constants.o cookie.o crypto.o defs.o log.o \
 	state.o main.o server.o timer.o id.o ipsec_doi.o kernel.o \
 	kernel_comm.o demux.o packet.o preshared.o dnskey.o rnd.o spdb.o \
-	sha1.o md5.o $(OBJSGCRYPT) $(LIBDESLITE) $(FREESWANLIB)
+	sha1.o md5.o $(OBJSGCRYPT) $(LIBDESLITE) $(FREESWANLIB) \
+	$(OPENSSLOBJS) $(LIBGMP)
 
 OBJSWHACK = whack.o $(FREESWANLIB)
 
-all: $(BINNAMEPLUTO) $(BINNAMEWHACK)
+#ifeq ($(USEOPENSSL),1)
+ifeq "$(USEOPENSSL)" "1"
+OBJSD2H = dir2hash.o
+endif
+
+all: $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINNAMED2H)
 
 install: all
-	$(INSTALL) $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINDIR)
-	$(INSTALL) pluto.8 $(PMANDIR)/ipsec_pluto.8
-	../utils/manlink $(PMANDIR) ipsec_pluto.8
-	$(INSTALL) ipsec.secrets.5 $(FMANDIR)
-	../utils/manlink $(FMANDIR) ipsec.secrets.5
+	$(INSTALL) $(BINNAMEPLUTO) $(BINNAMEWHACK) $(BINNAMED2H) \
+		$(PREFIX)/$(BINDIR)
+	$(INSTALL) pluto.8 $(PREFIX)/$(PMANDIR)/ipsec_pluto.8
+	../utils/manlink $(PREFIX)/$(PMANDIR) ipsec_pluto.8
+	$(INSTALL) ipsec.secrets.5 $(PREFIX)/$(FMANDIR)
+	../utils/manlink $(PREFIX)/$(FMANDIR) ipsec.secrets.5
 
 $(BINNAMEPLUTO): $(OBJSPLUTO)
 	$(CC) -o $(BINNAMEPLUTO) $(LDFLAGS) $(OBJSPLUTO) $(LIBSPLUTO)
@@ -166,6 +197,9 @@
 $(BINNAMEWHACK): $(OBJSWHACK)
 	$(CC) -o $(BINNAMEWHACK) $(OBJSWHACK) $(LIBSWHACK)
 
+$(BINNAMED2H): $(OBJSD2H)
+	$(CC) -o $(BINNAMED2H) $(OBJSD2H) $(LIBSD2H)
+
 distlist:
 	@echo $(DIST)
 
@@ -185,8 +219,10 @@
 realclean: clean
 
 clean:
-	$(RM) $(RMFLAGS) $(OBJSPLUTO) *.core core *~ a.out ktrace.out
-	$(RM) $(RMFLAGS) $(BINNAMEPLUTO) $(OBJSWHACK) $(BINNAMEWHACK)
+	$(RM) $(RMFLAGS) $(OBJSPLUTO) $(OBJSD2H) \
+		*.core core *~ a.out ktrace.out
+	$(RM) $(RMFLAGS) $(BINNAMEPLUTO) $(OBJSWHACK) $(BINNAMEWHACK) \
+		$(BINNAMED2H)
 
 .c.o:
 	$(CC) $(COPTS) $(ALLFLAGS) -c $<
@@ -198,6 +234,7 @@
 $(LIBDESLITE):
 	cd $(FREESWANLIBDIR) ; $(MAKE) libdes.a
 
+
 # Gather dependencies caused by explicit #includes within .c files
 #
 # Each .c is assumed to compile into a .o with the corresponding name.
@@ -221,9 +258,6 @@
 defs.o: defs.c
 demux.o: demux.c
 dnskey.o: dnskey.c
-dsa.o: dsa.c
-elgamal.o: elgamal.c
-gcryptfix.o: gcryptfix.c
 id.o: id.c
 ipsec_doi.o: ipsec_doi.c
 kernel.o: kernel.c
@@ -233,11 +267,9 @@
 md5.o: md5.c
 packet.o: packet.c
 preshared.o: preshared.c
-primegen.o: primegen.c
 rnd.o: rnd.c
 server.o: server.c
 sha1.o: sha1.c
-smallprime.o: smallprime.c
 spdb.o: spdb.c
 state.o: state.c
 timer.o: timer.c
@@ -259,6 +291,7 @@
 connections.o: dnskey.h
 connections.o: whack.h
 constants.o: constants.h
+constants.o: defs.h
 constants.o: packet.h
 cookie.o: constants.h
 cookie.o: defs.h
@@ -301,23 +334,6 @@
 dnskey.o: dnskey.h
 dnskey.o: packet.h
 dnskey.o: timer.h
-dsa.o: constants.h
-dsa.o: defs.h
-dsa.o: log.h
-dsa.o: rnd.h
-dsa.o: gcryptfix.h
-dsa.o: dsa.h
-elgamal.o: constants.h
-elgamal.o: defs.h
-elgamal.o: log.h
-elgamal.o: rnd.h
-elgamal.o: gcryptfix.h
-elgamal.o: elgamal.h
-gcryptfix.o: constants.h
-gcryptfix.o: defs.h
-gcryptfix.o: log.h
-gcryptfix.o: rnd.h
-gcryptfix.o: gcryptfix.h
 id.o: constants.h
 id.o: defs.h
 id.o: id.h
@@ -408,11 +424,6 @@
 preshared.o: dnskey.h
 preshared.o: log.h
 preshared.o: whack.h
-primegen.o: constants.h
-primegen.o: defs.h
-primegen.o: log.h
-primegen.o: rnd.h
-primegen.o: gcryptfix.h
 rnd.o: sha1.h
 rnd.o: constants.h
 rnd.o: defs.h
@@ -434,9 +445,6 @@
 server.o: whack.h
 sha1.o: sha1.h
 sha1.o: endian.h
-smallprime.o: constants.h
-smallprime.o: defs.h
-smallprime.o: gcryptfix.h
 spdb.o: constants.h
 spdb.o: defs.h
 spdb.o: id.h
